Viewing Issue Simple Details Jump to Notes ] View Advanced ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0000039 [libFirm] backend major always 2009-02-26 21:14 2009-05-15 16:50
Reporter Matze View Status public  
Assigned To xt3firm
Priority normal Resolution fixed  
Status closed   Product Version 1.16.0
Summary 0000039: Node numbers are not unique across functions in optimized mode
Description In optimized mode the compiler is simply returning the memory address of an node as node number. Unfortunately with the backend freeing functions after emitting them and reusing that space, some new nodes will get the same addresses as nodes from one of the previous functions.

The question is:
* Do we want node numbers to be unique across function in optimized mode?
* Should we simply use the integer field+counter from debug mode also in optimized mode?

I would answer both questions with yes.
Additional Information
Tags No tags attached.
Attached Files

- Relationships

-  Notes
(0000055)
Matze (administrator)
2009-02-26 21:30

Actually making node numbers not unique per-program would make them completeley useless, as for per-function unique numbers we already have node indices.

This might be a 3rd alternative: Remove get_node_nr() function completely in optimized mode, so noone can accidently use it for non-debugging stuff.
(0000056)
xt3firm (administrator)
2009-02-27 15:25
edited on: 2009-02-27 15:25

fixed in 25572: IRN node numbers exists now in release mode


- Issue History
Date Modified Username Field Change
2009-02-26 21:14 Matze New Issue
2009-02-26 21:14 Matze Status new => confirmed
2009-02-26 21:14 Matze version => 1.16.0
2009-02-26 21:15 Matze Summary Node numbers are not unique in optimized mode across functions => Node numbers are not unique across functions in optimized mode
2009-02-26 21:30 Matze Note Added: 0000055
2009-02-27 15:25 xt3firm Note Added: 0000056
2009-02-27 15:25 xt3firm Status confirmed => resolved
2009-02-27 15:25 xt3firm Resolution open => fixed
2009-02-27 15:25 xt3firm Assigned To => xt3firm
2009-02-27 15:25 xt3firm Note Edited: 0000056
2009-02-27 15:27 xt3firm Status resolved => closed
2009-02-27 17:28 Matze Status closed => resolved
2009-05-15 16:50 Matze Status resolved => closed


Mantis 1.1.5[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker